-- now Works with:
--		all GTA 3 DFF (Import & Export), just 1 incorrect so far!!
--		Bones & Skins
--		almost all GTA VC DFF 
--		Reflection supported

if DFFinInfo == undefined then fileIn (scriptspath+"\\GTA_Tools\\DFFin_Fn.mse") quiet:true 
if DFFoutInfo == undefined then fileIn (scriptspath+"\\GTA_Tools\\gDFFout_Fn.mse") quiet:true

Global Dummysize = 0.1		--control the dummy size, change it before pressing the Import Button 
Global SPscale = 1.0

--fns for developer to use:
--=========================
-- WhichRWver [filestream]			return: the RW file version

-- checkClump [filestream]			return: numbers of clumps in the file

-- CheckZmodLock [filestream]		return: TRUE if file is locked

-- DFFin [filestream] [Scale] [texture extension] [dummysize] [AutoSkin] \
--			[show Detail] [Name of SelectionSets]
--		the main import function, all object will be created inside this call
--		[scale]: global import scale of the dff file
--		[texture extension]: a text to tell the type of texture should MAX use
--								eg: ".tga"
--		[dummysize]: control the size of non-geometry object MAX will create 
--		[AutoSkin]: true/false if bones/skin data found. It will auto skin the data or not
--		[show Detail]: true/false option to display details in listener
--		[Name of SelectionSets]: everything in this import will be grouped with this given Name
--								 or undefined to skip grouping
--		return: the root object(geo/dummy) of the dff 

--DFFinInfo()						show the version of input functions 


-- RemapGeo [object]				return: undefined if the object is not supported
--											remapped object(Emesh) with same number
--											of UVs, verts, VertColors 

--gDFFout [objects] [ModulateMaretialColor] [UV switch] \
--			[VertColor switch] [Normal switch] [scale] [Version]
--		the main export function, all objects in [objects] will export to dff
--		[objects]: array contains all objects in scene will export to dff
--		[ModulateMaretialColor]: True/False whether use ModulateMaretialColor or not
--		[UV switch]: True/False whether Export UV coords or not
--		[VertColor switch]: True/False whether Export VertColor or not
--		[Normal switch]: True/False whether Export Normals or not
--		[scale]: global export scale of the dff file
--		[Version]: integer for use to identify the RW version

--DFFoutInfo()			 			show the version of output functions 


----------------------------------------------------------------------------------------------------

rollout DFFinPara "Import DFF" (
	Group "Multi. Clump" (
        spinner whichone "" type:#integer range:[1,1,1] align:#left fieldwidth:35 offset:[-3,3] across:2 enabled:false
        button useclump "Import" width:70 offset:[-3,0] enabled:false
	)
	group "" (
		label lbl1 "Image Type:" align:#left offset:[0,-7]
		radiobuttons textype "" labels:#("tga     ","bmp     ")
		spinner ISc "Import Scale: " fieldwidth:42 range:[0,100,SPscale] align:#left
		button imp "Import DFF" width:120 align:#left
	)
	group "" (
		checkbutton autoskin "A" width:17 tooltip:"Auto Skin after import dff character" highlightcolor:yellow align:#left across:2 offset:[0,-3]
		button skinchr "Skin the Character" width:103 tooltip:"Selected model must be Skin/bones ready" align:#right offset:[-2,-3]
		progressBar skinstate color:red height:8 offset:[0,-3]
		button RenameSel "Re-Name" width:61 tooltip:"Add BoneIndex to the name of objects for easy skinnig" align:#left across:2

		button RtnameSel "Restore" width:61 tooltip:"Restore Original names to selected objects" align:#right
	)
	
	on RenameSel pressed do (
		for obj in $selection do (
			onm = getUserProp obj "BoneIndex"
			if onm != undefined then (
				if onm <10 then obj.name = "0" + onm as string + "_" + (RestoreSpace obj.name)
				else obj.name = onm as string + "_" + (RestoreSpace obj.name)
			)
		)--end for	
	)

	on RtnameSel pressed do (
		for obj in $selection do (
			onm = getUserProp obj "FrameName"
			if onm != undefined then obj.name = RestoreSpace onm
		)--end for
	)--end on RenameSel

	on skinchr pressed do (
		if (SkinData != undefined)AND($selection.count == 1) then (
			global skn = $.modifiers[1]
			if (skn != undefined)AND(classof $ == Editable_mesh) then (
				if $.numVerts != SkinData[1].count then \
					messagebox "Skin Data Not correct!" title:"Skin Error"
				else (
					skn
					if (skinOps.GetNumberBones skn) != SkinData[3] then (
						messagebox "Bones count in skin Modifier Not correct!" title:"Skin Error"
					)	
 					else (
						skn
						for i = 1 to $.numVerts do (
							skinOps.SetVertexWeights skn i SkinData[1][i] SkinData[2][i]
							if (mod i 50) == 0 then skinstate.value = 100 * i/$.numVerts
						)
						skinstate.value = 0
						gc()
					)
				)
			) else messagebox "Skin modifier not found" title:"Skin Error"
		) else messagebox "Make sure you have selected the right character\nwith Skin modifier applied" title:""
	)--end on skinchr

	on Isc changed Val do (
		SPscale = Val
		try ( DFFexPara.ExSc.value = 1/Val ) catch()
	)

	on useclump pressed do (
		f = fopen fname "rb"
		if f != undefined then  (
			if whichone.value != 1 then fseek f no_clump[(whichone.value)] #seek_set
			texEx = case textype.state of (
				1: ".tga"
				2: ".bmp"
			)
			DFFin f ISc.value texEx dummysize autoskin.checked true undefined
			fclose f
			gc()
		) else (
			format "ERROR\n"
		)
	)--end on useclump
    
	on imp pressed do (
		fname = getopenfilename caption:"Read DFF File" types:"dff File (*.dff)|*.dff|"
		if fname != undefined then (
			f = fopen fname "rb"
			if f == undefined then ( Messagebox "Can't open the file!" title:"I/O Error" )
			else (
				no_clump = checkClump f
				if no_clump.count == 0 then messagebox "Not a Void DFF file!" title:"File Format Error"
				else (
					if no_clump.count == 1 then (
						texEx = case textype.state of (
							1: ".tga"
							2: ".bmp"
						)--end case
						DFFin f ISc.value texEx dummysize autoskin.checked true (getFilenameFile fname)
					) else (
						fclose f
						whichone.range = [1,no_clump.count,1]
						whichone.enabled = true
						useclump.enabled = true
						txt = "This DFF has " + no_clump.count as string + " Clumps.\nPlease choose one to Import!"
						Messagebox  txt title:""
					)
				)--end if/else no_clump
			)--end if/else f
		)
		fclose f
		gc()
	)--end on imp
    
)--end rollout DFFinPara


rollout DFFexPara "Export DFF" (

	checkbutton VCor3 "GTA 3" width:120 tooltip:"Use GTA3/VC version format" highlightcolor:green align:#center
	spinner ExSc "Export Scale: " fieldwidth:42 range:[0,100,1/SPscale] align:#left
		checkbutton MMC "MMC" width:30 align:#left highlightcolor:yellow tooltip:"use Modulate Material Color" checked:false across:4
		checkbutton TUV "UV" width:30 align:#center highlightcolor:yellow tooltip:"export Texture UV" checked:true
		checkbutton NOR "Nor" width:30 align:#center highlightcolor:yellow tooltip:"export Normal" checked:true
		checkbutton CPV "VCol" width:30 align:#right highlightcolor:yellow tooltip:"export Prelit Vertex Color"
	group "" (
		button exp "Export DFF (Text)" width:120 tooltip:"Only selected objects will export" align:#left
		button BSexp "Bones/Skin Export" width:120 tooltip:"Select the skinned Character only" offset:[-2,-3]
	)
	
	on BSexp pressed do (
		if $selection.count != 1 then messagebox "Select the skinned Character only!" title:"Selection Error"
		else (
			if (classof $.modifiers[1] != skin) then \
				messagebox "This object is not skinned correctly!\nSkin modifier must be on the topmost of the stack!!" title:"Skin Error"
			else (

				if VCor3.checked == true then	ver = 0X0C02FFFF			--VC Version
				else							ver = 0x0800FFFF			--Standard GTA3 Version

				max modify mode
				bkup = $.name
				$.name = "CharExpTemp"
				global skn = $.modifiers[1]
				skn
				boneCount = skinOps.getNumberBones skn
				boneReady = true
				global bonechain = #()
				for i = 1 to boneCount do (
					tmp = skinOps.getBoneName skn i 0
					tb = "append bonechain $'" + tmp + "'"
					bonechain
					execute tb
					tt = "getUserProp $'" + tmp + "' \"BoneID\""
					if (execute tt) == undefined then (
						boneReady = false
						exit
					)
					tt = "getUserProp $'" + tmp + "' \"BoneType\""
					if (execute tt) == undefined then (
						boneReady = false
						exit
					)					
				)--end for i
				$.name = bkup
				if boneReady == false then messagebox "You didn't set   BoneIDs/BoneTypes   properly!\nEach bone must have  'BoneID' & 'BoneType'  in it's User Properities." title:"BoneID/BoneType Error"
				else (
					for i = 1 to $.numverts do (
						if skinOps.GetVertexWeightCount skn i == 0 then boneReady = false
					)
				)
				if boneReady == false then messagebox "You didn't set   Skin/Vertices   properly!\nEach Vertex must be influence by at least 1 Bone." title:"Skin Error"
				else (

					fname = getsavefilename caption:"Export DFF TEXT File" types:"text File (*.txt)|*.txt|"
					if fname != undefined then (
						format "\n"             --Don't remove this, it solve some win98 user problem
						clearlistener()
						format "<!--path=\"%\"-->\n" fname
						
						expscale = $.scale * ExSc.value
						
						global SkinData = CreateSkinData $
						
						gwCharDFFout $ bonechain MMC.checked TUV.checked CPV.checked NOR.checked expscale ver
					
						format "//"             --Don't remove this, it solve some win98 user problem

					)
				)--if/else boneReady
				
			)--end check Skin modifier
		)--end check $	
	)--end on BSexp
	
	on VCor3 changed state do (
		if state == true then VCor3.text = "Vice City"
		else VCor3.text = "GTA 3"
	)
	
	on ExSc changed Val do (
 		SPscale = 1/Val
		try ( DFFinPara.ISc.value = 1/Val ) catch()
	)

	on exp pressed do (
		if $selection.count != 0 then (
		
		RootObj = checkRoot $selection
		if  RootObj != undefined then (
			----------------------
			--Scale the Root obj--
			----------------------
			bkupRootTran = RootObj.transform
			expscale = RootObj.scale * ExSc.value
			RootObj.transform = matrix3 [1,0,0] [0,1,0] [0,0,1] [0,0,0]
		
			if VCor3.checked == true then	ver = 0X0C02FFFF			--VC Version
			else							ver = 0x0800FFFF			--Standard GTA3 Version

			fname = getsavefilename caption:"Export DFF TEXT File" types:"text File (*.txt)|*.txt|"
			if fname != undefined then (
				format "\n"             --Don't remove this, it solve some win98 user problem
				clearlistener()
				format "<!--path=\"%\"-->\n" fname
			
				gDFFout $selection MMC.checked TUV.checked CPV.checked NOR.checked expscale ver

				format "//"             --Don't remove this, it solve some win98 user problem
			
			)--end if f!=undefined	
		
			RootObj.transform = bkupRootTran		
		
		)--end if RootObj
		
		) else (MessageBox "Select the Objects you want to export.\n And then press 'Export DFF' button" title:"Selection Error") --end

	)--end on exp

)--end rollout DFFexPara


rollout aboutRoll "About" (
	label l1 "GTA DFF IO Beta"
	label l2 "**GMax Version**"
	label l3 " " 
	label l4 "by Kam" align:#left across:2
	label l5 "04Feb05" align:#right
	label l6 "kam.lai@ntlworld.com"
	label l7 " "
	label l8 "Special Thanks Delfi" align:#left
	label l9 "for his wonderful T2B.exe" align:#right
	label lA "without it"
	label lB "GMax can't export binary!"
)
rollout howRoll "How To Export" (
	label l0 ">Press Export button." align:#left
	label l1 "- codes will be listed in" align:#left
 	label l2 "GMax's listener." align:#right
	label l3 ">Copy && Paste to a text file." align:#left
	label l4 ">In DOS commandline type:" align:#left
	label l5 "\"T2B <file.txt> <file.dff>\"" 
)


rollout dmyHelper "Dummies/Bones Helper" (
	spinner dmyboxsize "Size: " range:[0.00000001,100000,dummysize]
	button dmyasBox "Box" width:40 tooltip:"Show Dummies/bones as box" align:#left across:3
	button dmynLink "Link" width:40 tooltip:"Show Dummies/bones as box with Links" align:#center	
	button dmyasBone "Bone" width:40 tooltip:"Show Dummies/bones as bone" align:#right

	on dmyboxsize changed val do (
		for dmy in $selection where classof dmy == Dummy do (
			dmy.boxsize = [val,val,val]
		)	
	)

	on dmyasBox pressed do (
		for dmy in $selection where classof dmy == Dummy do (
			dmy.showLinksOnly = false
			dmy.showLinks = false
		)
		forceCompleteRedraw()
	)
	on dmynLink pressed do (
		for dmy in $selection where classof dmy == Dummy do (
			dmy.showLinksOnly = false
			dmy.showLinks = true
		)
		forceCompleteRedraw()
	)
	
	on dmyasBone pressed do (
		for dmy in $selection where classof dmy == Dummy do dmy.showLinksOnly = true
		forceCompleteRedraw()
	)
)--end rollout dmyHelper

if Kam_GTA != undefined then closeRolloutFloater Kam_GTA
Kam_GTA = newRolloutFloater "DFF IO v0.41b" 175 385 10 100		
addRollout DFFinPara Kam_GTA 	--rolledup:true
addRollout DFFexPara Kam_GTA 	rolledup:true
addRollout dmyHelper Kam_GTA 	rolledup:true
addRollout howRoll Kam_GTA 		rolledup:true
addRollout aboutRoll Kam_GTA 	rolledup:true